<?php

class Shopworks_BillinkOsc_Model_Observer_Billink
{
    const ONESTEPCHECKOUT_DISPLAY_TAX_INCLUDED_CONFIG_PATH = 'onestepcheckout/general/display_tax_included';
    const ONESTEPCHECKOUT_MODULE_NAME = 'onestepcheckout';

    /**
     * One step checkout does not use the default Magento Frontend Renderers. So we have to manipulate the taxes manually
     * @param Varien_Event_Observer $obs
     */
    public function quoteFeeBeforeFetch(Varien_Event_Observer $obs)
    {
        $result = $obs->result;

        /** @var Mage_Sales_Model_Quote_Address $address */
        $address = $result->getAddress();
        $amount = $result->getAmount();

        $isOSCRequest = Mage::app()->getRequest()->getModuleName() == self::ONESTEPCHECKOUT_MODULE_NAME;
        $isOSCDisplayTaxIncl = Mage::getStoreConfigFlag(self::ONESTEPCHECKOUT_DISPLAY_TAX_INCLUDED_CONFIG_PATH);

        if($amount && $isOSCRequest)
        {
            if($isOSCDisplayTaxIncl)
            {
                $result->setAmount($address->getBillinkFeeInclTax());
            }
            else
            {
                $billinkFeeExclTax = $address->getBillinkFeeInclTax() - $address->getBillinkFeeTax();
                $result->setAmount($billinkFeeExclTax);
            }
        }
    }
}